/*
 * @(#)nereg.h	1.5 5/28/92 Interphase
 */

/***************************************************************************
 * This code is copyright 1991 by Interphase Corporation.		   *
 * All rights reserved.							   *
 *									   *
 * This code contains confidential information and trade secrets of	   *
 * Interphase Corporation which shall not be reproduced or	           *
 * transferred to other programs or disclosed to others or used for	   *
 * manufacturing or any other purpose without prior written permission of  *
 * Interphase Corporation.  Use of copyright notice is precautionary       *
 * and does not imply publication or intent thereof.			   *
 ***************************************************************************/


/*
 * nereg.h - NFS Eagle def's
 */

#ifndef _nereg_h
#define _nereg_h

#define	NIORESET	_IO(n, 0) 
#define	NIODNLD		_IOW(n, 1, struct ne_dnld)
#define	NIORELOC	_IOWR(n, 2, struct ne_reloc_usr)
#define NIOGETSTAT	_IOW(n, 3, struct iovec)
#define NIOZEROSTAT	_IO(n, 4)
#define NIOGNFSSTAT	_IOW(n, 5, struct iovec)
#define NIOZNFSSTAT	_IO(n, 6)
#define NIOGELSTAT	_IOW(n, 7, struct iovec)
#define NIONFSSTART	_IO(n, 8)
#define NIOISUP		_IOR(n, 9, unsigned int)
#define NIOISTHERE	_IOR(n, 10, unsigned int)
#define	NIONFSRUN	_IO(n, 11)
#define	NIOCSARP	_IOW(n, 12, struct arpreq)
#define	NIOCDARP	_IOW(n, 13, struct arpreq)
#define NIOWATCH	_IO(n, 14)
#define NIOUPSHIO	_IO(n, 15)
#define NIOUPBUFF	_IO(n, 16)
#define NIOUPPROG	_IO(n, 17)
#define NIOUPLOAD	_IOW(n, 18, struct iovec)
#define NIOGETQUEUE	_IOW(n, 19, struct iovec)
#define NIOSETPARM	_IOW(n, 20, struct iovec)
#define NIOGETPARM	_IOW(n, 21, struct iovec)
#define NIOGETVERSION	_IOW(n, 22, struct iovec)
#define NIOSTOP		_IO(n, 23)
#define NIOGETADDR	_IOW(n, 24, struct iovec)
#define NIOCONSRX	_IOWR(n, 25, struct iovec)
#define NIOCONSTX	_IOW(n, 26, char)
#define NIOSTARTCONS	_IO(n, 27)
#define NIOSTOPCONS	_IO(n, 28)
#define NIOTXDELAY	_IOW(n, 29, struct ne_txdelay)
#define NIOSETDNLD	_IOW(n, 30, struct iovec)
#define NIOADDIPADDR	_IOW(n, 31, unsigned long)

/* ioctl for get board ethernet address stored in NVRAM at the factory */
#define NIOGBEADDR	_IOW(n, 33, struct iovec)
/*
 * Debuggin flags to turn on checksums DVMA Buffers
 * Debuggin flag to turn on DVMA Datalink Buffer checksum
#define	NE_DLBUF_CKSUM	1
#define NE_NFSBUF_CKSUM	1
 */

#ifdef sun4
#define	NE_VERS_STRING	"e4207-1c"
#else sun4
#define	NE_VERS_STRING	"e4207-2b"
#endif sun4

/*
 * This constant really belongs in ../sun/seg_kmem.h
 * We define it here to avoid modifying a Sun distribution file.
 * Currently, SEGKMEM_XXX constants defined in ../sun/seg_kmem.h
 * use the range [0-6]. We picked up a remote constant (99), to avoid
 * any likely conflicts with new values defined by Sun in the future.
 * This bet should still be validated on every new port.
 */
#define SEGKMEM_NE		99

#define NNE_MAX			8	/* max. number of devices in the system */

#define K			1024
#define NE_SHIO_SIZE		2*K

#define NE_BUFRAM_SIZE		510*K
#define NE_BUFRAM_START		0xC00000
#define NE_BUFRAM_MASK		0xFFF80000

#define NE_PROGRAM_START	0x00000000
#define NE_PROGRAM_SIZE		510*K

#define NE_WATCH_TIME		10	/* secs before declaring that the board is dead */

#define NE_MAX_NFS		24

#ifdef sun4m
#define NE_NUM_H2B_DLBLK	2	/* DMA read block */
#define NE_NUM_B2H_DLBLK	2	/* DMA write block */
#endif sun4m

/* cmd's for second long word location in shortio */
#define	NE_RESET_CMD		~0	/* hard reset */
#define	NE_STOP_CMD		0	/* stop all activity */
#define	NE_PTOB_XFER		1	/* program to buffer memory xfer */

#define NE_CBOK			0xCB

#define MAKE_LONG(a,b,c,d) \
	( ( (unsigned int)(a) << 24 ) | ( (unsigned int)(b) << 16 ) | \
	  ( (unsigned int)(c) <<  8 ) | ( (unsigned int)(d) ) )

#define CB_CBOK		MAKE_LONG('C','B','O','K')
#define CB_BOOT		MAKE_LONG('B','O','O','T')
#define	CB_JUMP		MAKE_LONG('J','U','M','P')

#define NE_HOSTOK	MAKE_LONG('N','E','O','K')
#define NE_SWOK		MAKE_LONG('S','W','O','K')

/*
 * define's for ne_status
 */
#define NE_CB_UP	1
#define NE_ATTACH_OK	2
#define NE_SW_UP	4
#define NE_PTOB_WAIT	8
#define NE_WDOG_WAIT	16
#define NE_SWUP_WAIT	32
#define NE_STAT_WAIT	64
#define NE_ELST_WAIT	128
#define NE_RPCST_WAIT	256
#define NE_VERS_WAIT	512
#define NE_LCP_MODE	1024

/*
 * Flags passed to ne_signal_procs.
 */
#define NE_ALL_SIG	~0
#define NE_PTOB_SIG	1
#define NE_SWUP_SIG	2
#define NE_WDOG_SIG	4
#define NE_TXWAIT_SIG	8
#define NE_STAT_SIG	16
#define NE_ELST_SIG	32
#define NE_RPCST_SIG	64
#define NE_CONS_SIG	128
#define NE_VERS_SIG	256

#define NE_RDY_INT	1	/* indicates readiness to communicate */
#define NE_RX_INT	2	/* incoming data */
#define NE_TX_INT	3	/* more room available on the h2b ring */
#define NE_BUF_INT	4	/* more buffers available in DVMA space */
#define NE_URX_INT	5	/* rx char (host console pseudo-uart) */
#define NE_UTX_INT	6	/* tx char (host console pseudo-uart) */
#define NE_PTOB_INT 7	/* completion of prog to buf transfer */

#define NE_RDY_STAT	1
#define NE_TXWAIT_STAT	2
#define NE_BUFWAIT_STAT	4
#define NE_HOST_CONS	8

#define MILLISECOND		1000
#define SECOND			1000*MILLISECOND
#define NE_MAX_RST_DELAY	5*SECOND

#define NE_MAX_INT_LEVEL	7
#define NE_MAX_INT_VECTOR	255

#define NE_GETMSG_PATIENCE	10000

#define NE_FULL		1
#define NE_EMPTY	0

#ifndef TRUE
#define TRUE		1
#endif

#ifndef FALSE
#define FALSE		0
#endif

#define NE_TRAILER_LEN	16

/* Ring Control Block structure.
 * There is one such structure for host to board (h2b) messages,
 * and another for board to host (b2h) messages.
 */
typedef struct ne_rcb {
	unsigned int	rcb_read_ptr;	/* address that will be read next */
	unsigned int	rcb_read_cnt;	/* ring read count, ever increasing */
	unsigned int	rcb_write_ptr;	/* address where writer will write next */
	unsigned int	rcb_write_cnt;	/* ring write count, ever increasing */
} NERCB, *NERCBP;					/* used to be RC, *RCP */

typedef struct ne_sw {
	unsigned int sw_host_status;	/* host is ready to communicate */
	unsigned int sw_board_status;	/* board is ready to communicate */
	unsigned int sw_b2h_int;	/* identifies board interrupts */
	unsigned int sw_h2b_int;	/* identifies and causes host interrupts */
	unsigned int sw_bufstruct_size;	/* size of dvma buf structures */
	unsigned int sw_dvma_vaddr;	/* virtual address */
	unsigned int sw_dvma_paddr;	/* physical bus address */
	unsigned int sw_shio_vaddr;	/* virtual address */
	unsigned int sw_shio_paddr;	/* physical board address */
	unsigned int sw_bufram_vaddr;	/* virtual address */
	unsigned int sw_bufram_paddr;	/* physical board address */
	unsigned int sw_b2h_int_lvl;	/* level board should interrupt at */
	unsigned int sw_b2h_int_vec;	/* vector board should interrupt with */
	unsigned int sw_board_unit;	/* unit number of board, and total # */
	char	     sw_enet[8];	/* enet addr of board */
	unsigned int sw_dvma_nfssz;	/* dvma size allocated for nfs agents */
	unsigned short sw_h2b_uast;	/* h2b pseudo-uart status */
	unsigned short sw_h2b_uadt;	/* h2b pseudo-uart data */
	unsigned short sw_b2h_uast;	/* b2h pseudo-uart status */
	unsigned short sw_b2h_uadt;	/* b2h pseudo-uart  data */
} NESW, *NESWP;

/* Board control structure.
 * The first two long words of this structure are tied
 * to the hardware.
 * The rest of the structure is under firmware control.
 */
typedef struct ne_bctl {
		unsigned int    bctl_reset_status;
		unsigned int    bctl_reset_control;
		unsigned int    bctl_shio_base;
		unsigned int    bctl_buff_base;
		unsigned int    bctl_h2b_end;
		unsigned int    bctl_b2h_end;
		struct ne_rcb   bctl_h2b_rcb;
		struct ne_rcb   bctl_b2h_rcb;
		struct ne_sw    bctl_sw;
} NEBCTL, *NEBCTLP;				/* used to be ERH, *ERHP */

/* Old Ring Control structure. Would like to have it replaced with rcb in 
 * Interphase PROM's.
 * There is one such structure for host to board (h2b) messages,
 * and another for board to host (b2h) messages.
 */
typedef struct ne_rc {
	unsigned int	rc_read_ptr;	/* address that will be read next */
	unsigned int	rc_write_ptr;	/* address where writer will write next */
} NERC, *NERCP;					/* used to be RC, *RCP */

/* Eagle Ring Hardware structure. Borrowed from Interphase PROM's. Would like
 * to have it replaced with bctl in Interphase PROM's.
 * The first two long words of this structure are tied
 * to the hardware.
 * The rest of the structure is under firmware control.
 */
typedef struct ne_erh {
		unsigned int   erh_reset_status;
		unsigned int   erh_reset_control;
		unsigned int   erh_shio_base;
		unsigned int   erh_buff_base;
		unsigned int   erh_h2b_end;
		unsigned int   erh_b2h_end;
		struct ne_rc   erh_h2b_rc;
		struct ne_rc   erh_b2h_rc;
} NEERH, *NEERHP;				/* used to be ERH, *ERHP */

/*
 * Structure definitions used in dvma memory buffer management.
 */

struct ne_bufdesc {
	struct ne_bufdesc	*bd_free;		/* free list pointer */
	char			*bd_base;		/* base of data area */
	char			*bd_data;		/* current start of data */
	unsigned short		bd_class;		/* class this buf. belongs to */
	unsigned short		bd_size;		/* size of data area */
	unsigned short		bd_len;			/* current data length */
	unsigned short		bd_ref;			/* reference count */
};

#ifdef sun4m
struct ne_bufpool {
	unsigned short		bp_class;		/* class maps 1-1 with size */
	unsigned short		bp_size;		/* size of buffers in pool */
	unsigned short		bp_count;		/* number of free buffers in pool */
	unsigned short		bp_bufsperblk;		/* buffers per Buffer Block */
	struct ne_bufdesc	*bp_bd_free;		/* pointer to free list of bufs. */
	unsigned int		bp_locount;		/* all time low count */
	unsigned int		bp_runout;		/* # of times pool dried out */
	unsigned int		bp_rescue;		/* # of rescues to a lower pool */
	unsigned int		bp_semaphore[2];	/* access semaphore */
};
#else sun4m
struct ne_bufpool {
	unsigned int		bp_class;		/* class maps 1-1 with size */
	unsigned int		bp_size;		/* size of data area in class */
	unsigned int		bp_count;		/* number of buffers in this pool */
	struct ne_bufdesc	*bp_bd_free;		/* pointer to free list of bufs. */
	struct ne_bufdesc	*bp_bd_first;		/* first buffer descriptor */
	struct ne_bufdesc	*bp_bd_last;		/* last buffer descriptor */
	char			*bp_data_first;		/* start of data area */
	char			*bp_data_last;		/* end of data area of this pool */
	unsigned int		bp_locount;		/* all time low count */
	unsigned int		bp_runout;		/* # of times pool dried out */
	unsigned int		bp_rescue;		/* # of rescues to a lower pool */
	unsigned int		bp_semaphore[2];	/* access semaphore */
};
#endif sun4m

struct ne_queue {
	struct ne_queue	*q_next;	/* next element on the queue */
	unsigned int	q_data;		/* data carried by this queue element */
};

struct ne_queue_ctl {
	struct ne_queue *qctl_head;		/* head of queue */
	struct ne_queue *qctl_tail;		/* tail of queue */
	int		qctl_want;		/* # of daemons asleep on the queue */
	int		qctl_minwant;		/* all-time min # of daemons asleep */
	int    		qctl_exc;		/* current queue excess */
	int    		qctl_maxexc;		/* all-time high qctl_excess */
	int		qctl_count;		/* current queue count */
};

struct ne_txqueue_ctl {
	struct ne_queue *txq_head;		/* head of queue */
	struct ne_queue *txq_tail;		/* tail of queue */
	int             txq_count;		/* current queue count */
	int             txq_high;		/* all-time high queue count */
};

/* The following number should be greater than or equal to the number
 * of outstanding requests at any time. So it is the product of max number
 * of active NFS contexts per NC times the maximum possible NC's.
 * we cannot use the runtime count of valid NC's that is kept in the driver
 * because the following definition has to be used for static array allocation
 */
#define NE_MAX_QUEUE	NE_MAX_NFS * NNE_MAX
#define NE_QCTL_WANT	1024		/* any number higher than # of nfsd's */
#define NE_MAX_TXQUEUE	32		/* queue elements for processes, other
					 * than nfsd's, asleep with txwait.
					 */
#define VERSION_SIZE 	40		/* Eagle's version string size */

/*
 * Everything goes ...
 */
struct ne_softc {
/*000*/	unsigned int		ne_status;		/* status of the interface */
/*004*/	unsigned int 		ne_unit;		/* instance of the device */
/*008*/	struct mb_device 	*ne_info;		/* gets us to md */
/*00C*/	unsigned int 		*ne_hd;			/* same as md->md_hd, mb_hd */
/*   */
/*010*/	char 			*ne_shio_vaddr;		/* vaddr of shortio space */
/*014*/	char 			*ne_shio_paddr;		/* paddr of shortio space */
/*018*/	unsigned int		ne_shio_offset;		/* paddr to vaddr of shio */
/*01C*/	unsigned int		ne_shio_len;		/* length of shortio space */
/*   */
/*020*/	struct ne_bctl		*ne_bctl;		/* vaddr of ctl area (= shio) */
/*024*/	unsigned int 		*ne_cb;			/* vaddr of dnld area in shio */
/*028*/	unsigned int		ne_cb_len;		/* size of download area */
/*02C*/	unsigned int		ne_rcb_done;		/* board reset and rcb setup */
/*   */
/*030*/	char			*ne_bufram_baddr;	/* vme addr of Eagle buf ram */
/*034*/	char			*ne_bufram_vaddr;	/* vaddr of Eagle buffer ram */
/*038*/	char			*ne_bufram_paddr;	/* paddr of Eagle buffer ram */
/*03C*/	unsigned int		ne_bufram_offset;	/* paddr to vaddr of buf ram */
/*040*/	unsigned int		ne_bufram_size;		/* size of Eagle buffer ram */
/*044*/	unsigned int		ne_bufstruct_size;	/* size of bufdesc structures */
/*048*/	unsigned int		ne_dnld_ptr;		/* current download pointer */
/*04C*/	unsigned int		ne_upld_ptr;		/* current upload pointer */
/*   */
/*050*/	unsigned int		ne_int_level;		/* level of Eagle ints */
/*054*/	unsigned int		ne_int_vector;		/* vector for Eagle ints */
/*058*/	unsigned int		*ne_h2b_int;		/* vaddr of h2b int qualifier */
/*05C*/	unsigned int		*ne_b2h_int;		/* vaddr of b2h int qualifier */
/*   */
/*060*/	char			*ne_dvma_kbase;		/* dvma base in kernel space */
#ifdef sun4
/*064*/	char 			*ne_dvma_vaddr;		/* vaddr of dvma area */
#else sun4
/*064*/	char 			*ne_dvma_kvaddr;		/* vaddr of dvma area */
#endif sun4
/*068*/	char			*ne_dvma_paddr;		/* paddr of dvma area */
/*06C*/	unsigned int		ne_dvma_offset;		/* paddr to vaddr of dvma */
/*070*/	unsigned int		ne_dvma_size;		/* size of dvma area */
/*074*/	unsigned int		ne_dvma_nfssz;		/* size of nfs dvma area */
/*078*/	unsigned int		ne_dvma_done;		/* dvma area set up */
/*07C*/	struct ne_bufpool	*ne_dvma_bufpool;	/* ptr to bufpool structures */
/*   */
/*080*/	struct ne_rcb		*ne_h2b_rcb;		/* host to board ring ctl blk */
/*084*/	unsigned int		ne_h2b_base;		/* base of host to board ring */
/*088*/	unsigned int		ne_h2b_end;		/* end of host to board ring */
/*08C*/	unsigned int		ne_h2b_bound;		/* marker for wrap around */
/*   */
/*090*/	struct ne_rcb		*ne_b2h_rcb;		/* board to host ring ctl blk */
/*094*/	unsigned int		ne_b2h_base;		/* base of board to host ring */
/*098*/	unsigned int		ne_b2h_end;		/* end of board to host ring */
/*09C*/	unsigned int		ne_b2h_bound;		/* marker for wrap around */
/*   */
/*0A0*/	unsigned int		ne_h2b_maxgap;		/* max gap between r/w counts */
/*0A4*/	unsigned int		ne_b2h_maxgap;		/* max gap between r/w counts */
/*0A8*/	unsigned int		ne_bufint_icnt;		/* # of buf ints from device */
/*0AC*/	unsigned int		ne_bufint_ocnt;		/* # of buf ints to device */
/*   */
/*0B0*/	unsigned int		ne_rxint_icnt;		/* # of rx ints from device */
/*0B4*/	unsigned int		ne_rxint_ocnt;		/* # of rx ints to device */
/*0B8*/	unsigned int		ne_txint_icnt;		/* # of tx ints from device */
/*0BC*/	unsigned int		ne_txint_ocnt;		/* # of tx ints to device */
/*   */
/*0C0*/	struct ne_queue_ctl	*ne_queue_ctl;		/* nfsd queue ctl structure */
/*0C4*/	struct ne_queue		**ne_queue_free;	/* list of free queue nodes */
/*0C8*/	unsigned int		ne_queue_done;		/* nfsd queue set up */
/*0CC*/	struct ne_txqueue_ctl	*ne_txqueue_ctl;	/* txwait queue ctl structure */
/*0D0*/	struct ne_queue		**ne_txqueue_free;	/* list of free txqueue nodes */
/*0D4*/	unsigned int		ne_txqueue_done;	/* txwait queue set up */
/*0D8*/	unsigned int		ne_dnld_lim;		/* upper bound on current dnld*/
/*0DC*/	unsigned int		ne_upld_lim;		/* upper bound on current upld*/
/*   */
/*0E0*/	unsigned int 		ne_rdyint_icnt;		/* # of rdy ints from device */
/*0E4*/	unsigned int 		ne_ptobint_icnt;	/* # of ptob ints from device */
/*0E8*/	unsigned int 		ne_urxint_icnt;		/* # of urx ints from device */
/*0EC*/	unsigned int 		ne_utxint_icnt;		/* # of utx ints from device */
/*0F0*/	unsigned int		ne_msg_runout;		/* # of times ran out of msg */
/*   */
/*0F4*/	char			ne_banner[32];		/* to deposit messages */
/*   */
/*114*/	char			ne_def_mac[6];		/* default mac addr of board */
/*11A*/	char			ne_eversion[VERSION_SIZE];
/*142*/	struct arpcom		ne_ac;			/* arp common structure */
/*1D4*/	int			ne_txstatus;		/* transmitter status update every second */
/*1D8*/	unsigned int		ne_fram;		/* receive framing error */
/*1DC*/	unsigned int		ne_crc;			/* receive CRC error */
/*1E0*/	unsigned int		ne_oflo;		/* receive overrun error */
/*1E4*/	unsigned int		ne_uflo;		/* transmit underflow error */
/*1E8*/	unsigned int		ne_tlcol;		/* transmit late collision */
/*1EC*/	unsigned int		ne_trtry;		/* transmit retry errors (after 16 retries) */
/*1F0*/	unsigned int		ne_tnocar;		/* no carrier error */
/*1F4 begining of next entry, (ie. ne_softc[n+1])*/
};

/* Eagle's transmitter status code */
#define TMD_BUFF 0x8000
#define TMD_UFLO 0x4000
#define TMD_LCOL 0x1000
#define TMD_LCAR 0x0800
#define TMD_RTRY 0x0400

/* Board Data Link Statistics Structure
 */
struct ne_el_stat {
	unsigned int nel_ipackets;
	unsigned int nel_ierrors;
	unsigned int nel_opackets;
	unsigned int nel_oerrors;
	unsigned int nel_collisions;
	unsigned int nel_qlen;
	unsigned int nel_qdrops;
};

#define NS_NETQ_TYPES	2

/* Board Statistics Structure.
 */
struct ns_stat {
	unsigned int nst_cpu_cur;
	unsigned int nst_cpu_hi;

	unsigned int nst_xprt_cur;
	unsigned int nst_xprt_hi;
	unsigned int nst_xprt_runout;

	unsigned int nst_dvma_cur;
	unsigned int nst_dvma_lo;
	unsigned int nst_dvma_runout;

	unsigned int nst_sktq_cur;
	unsigned int nst_sktq_hi;

	unsigned int nst_jobq_cur;
	unsigned int nst_jobq_hi;
	unsigned int nst_jobq_runout;

	unsigned int nst_netq_cur[NS_NETQ_TYPES];
	unsigned int nst_netq_hi[NS_NETQ_TYPES];
	unsigned int nst_netq_runout[NS_NETQ_TYPES];

	unsigned int nst_mbuf_cur;
	unsigned int nst_mbuf_lo;
	unsigned int nst_mbuf_runout;

	unsigned int nst_msg_runout;

	unsigned int nst_nfso_count;

	unsigned int nst_dltx_count;

	unsigned int nst_dmaq_cur;
	unsigned int nst_dmaq_hi;

	unsigned int nst_dcb_cur;
	unsigned int nst_dcb_lo;
	unsigned int nst_dcb_runout;

	unsigned int nst_sge_cur;
	unsigned int nst_sge_lo;
	unsigned int nst_sge_runout;

	struct ne_el_stat nst_el;

#define	nst_el_ipackets		nst_el.nel_ipackets
#define	nst_el_ierrors		nst_el.nel_ierrors
#define	nst_el_opackets		nst_el.nel_opackets
#define	nst_el_oerrors		nst_el.nel_oerrors
#define	nst_el_collisions	nst_el.nel_collisions
#define nst_el_qlen		nst_el.nel_qlen
#define nst_el_qdrops		nst_el.nel_qdrops

	unsigned int nst_el_crc;	/* ls->ls_crc on Eagle */
	unsigned int nst_el_fram;	/* ls->ls_fram on Eagle */
	unsigned int nst_el_oflo;	/* ls->ls_oflo on Eagle */

	unsigned int nst_el_tBUFF;	/* ls->ls_tBUFF on Eagle */
	unsigned int nst_el_tlcol;	/* ls->ls_tlcol on Eagle */
	unsigned int nst_el_trtry;	/* ls->ls_trtry on Eagle */
	unsigned int nst_el_tnocar;	/* ls->ls_tnocar on Eagle */
	unsigned int nst_el_uflo;	/* ls->ls_uflo on Eagle */

};

/* Host Statistics Structure.
 */
struct ne_stat {
	unsigned int net_nfsd_cur;
	unsigned int net_nfsd_lo;
	unsigned int net_neq_cur;
	unsigned int net_neq_hi;
	unsigned int net_msg_runout;
	unsigned int net_dlrx_count;
	unsigned int net_nfsi_count;
	unsigned int net_h2b_hi;
	unsigned int net_b2h_hi;
};

/* Combined Statistics Structure.
 */
struct ne_usrstat {
	unsigned int ne_status;
	struct ne_stat ne_st;
	struct ns_stat ns_st;
};

struct ne_elstat {
	unsigned int status;
	struct ne_el_stat elstat;
};

/* XXX - The following structure definition is taken from svc_kudp.c .
 * It is rather ugly to redefine it here and be prone to unexpected
 * changes in the original structure definition in svc_kudp.c .
 */
struct rsstat {
	int rscalls;
	int rsbadcalls;
	int rsnullrecv;
	int rsbadlen;
	int rsxdrcall;
};

struct ne_rpcstat {
	unsigned int status;
	struct rsstat rss;
};

/* parameters of the download ioctl */
struct ne_dnld {
	struct iovec	dn_iov;		/* to copy data from */
	unsigned int	dn_offset;	/* offset in buffer ram */
	unsigned int	dn_parm;	/* parameter: unused now */
};

/* parameters of the relocate and jump ioctl */
#define NE_VERS_MATCH		0
#define NE_VERS_MISMATCH	1
#define NE_VERS_LEN		12
struct ne_reloc_usr {
	unsigned int	rel_off;		/* offset in buffer ram */
	unsigned int	rel_to;			/* address in program ram */
	unsigned int	rel_len;		/* length of program */
	unsigned int	rel_start;		/* start address of program */
	unsigned int	rel_parm;		/* parameter: unused now */
	unsigned int	rel_stat;		/* return status */
	char        	rel_hv[NE_VERS_LEN];	/* host version */
	char        	rel_bv[NE_VERS_LEN];	/* board version */
};

struct ne_reloc {
	unsigned int	rel_off;		/* offset in buffer ram */
	unsigned int	rel_to;			/* address in program ram */
	unsigned int	rel_len;		/* length of program */
	unsigned int	rel_start;		/* start address of program */
};

/* parameters of the setparm/getparm ioctl's */
struct ne_parm {
	unsigned int	parm_ref;		/* parameter reference number */
	unsigned int	parm_val;		/* parameter value */
	unsigned int	parm_ctl;		/* control field */
};

/* table keep internally */
struct ne_parm_tbl {
	unsigned int	parm_ref;		/* parameter reference number */
	unsigned int	parm_val;		/* current set parameter value */
	unsigned int	parm_def;		/* default value field */
};

#define NFSON_PARM	0	/* parm to enable/disable NFS function */
#define RETRY_PARM	1	/* parm to enable/disable NFS retry filter */
#define SOURCECACHE_PARM 2	/* parm to enable/disable route/arp cacheing */
#define UDPCKSUM_PARM	3	/* parm to enable/disable UDP checksums */
#define LCP_MODE_PARM	4	/* parm to enable/disable LCP mode */
#define TOTAL_PARM	5	/* total number of parms */

/* parm default definitions */
#define	NFSON_DEF	1	/* default is on, although initially it is off */
#define	RETRY_DEF	1	/* default is on */
#define SCACHE_DEF	1	/* default is on */
#define UCKSUM_DEF	0	/* default is off */
#define LCP_MODE_DEF	0	/* default is off */

/* ctl field definitions */
#define DEFAULT_VAL	-1	/* set by user to ask setting parm to its default */
#define PARM_SUCCESS	0	/* set by ne to indicate success of operation */
#define PARM_FAILURE	1	/* set by ne to indicate failure of operation */

/* Message Control Block.
 * Every message passed through the message ring begins with such a structure.
 */
typedef struct ne_mcb {
	unsigned int	mcb_msg;
	unsigned int	mcb_len;
	unsigned int	mcb_cookie;
} NEMCB, *NEMCBP;			/* used to be CCB, *CCBP */

#define NE_MSG_BASE_SHIFT	28	/* topmost nibble is base */
#define NE_MSG_OFF_MASK		0xff	/* bottommost byte is offset */

#define NE_TEST_BASE	(0 << NE_MSG_BASE_SHIFT)
#define	NE_MGMT_BASE	(1 << NE_MSG_BASE_SHIFT)
#define	NE_DL_BASE	(2 << NE_MSG_BASE_SHIFT)
#define NE_RPC_BASE	(3 << NE_MSG_BASE_SHIFT)
#define NE_INVL_BASE	(4 << NE_MSG_BASE_SHIFT)

#define NE_COPY	(NE_TEST_BASE + 0)	/* host does data copy */
#define NE_DVMA	(NE_TEST_BASE + 1)	/* dma does data copy */
#define NE_TINV	(NE_TEST_BASE + 2)

#define NE_NOOP	(NE_MGMT_BASE + 0)
#define	NE_IOSA (NE_MGMT_BASE + 1)	/* set address ioctl */
#define	NE_IOSF (NE_MGMT_BASE + 2)	/* set flags ioctl */
#define	NE_IOSB	(NE_MGMT_BASE + 3)	/* set broadcast address ioctl */
#define NE_IOSN	(NE_MGMT_BASE + 4)	/* set netmask ioctl */
#define NE_IOAS (NE_MGMT_BASE + 5)	/* arp set ioctl */
#define NE_IOAD	(NE_MGMT_BASE + 6)	/* arp delete ioctl */
#define NE_IOSM	(NE_MGMT_BASE + 7)	/* set metric ioctl */
#define NE_IOGS	(NE_MGMT_BASE + 8)	/* get stats ioctl */
#define NE_IOZS	(NE_MGMT_BASE + 9)	/* zero stats ioctl */
#define NE_IORS	(NE_MGMT_BASE + 10)	/* stats response */
#define NE_IOGN	(NE_MGMT_BASE + 11)	/* get nfsstat ioctl */
#define NE_IOZN	(NE_MGMT_BASE + 12)	/* zero nfsstat ioctl */
#define NE_IORN	(NE_MGMT_BASE + 13)	/* nfsstat response */
#define NE_IOGE	(NE_MGMT_BASE + 14)	/* get el stats ioctl */
#define NE_IORE	(NE_MGMT_BASE + 15)	/* el stats response */
#define NE_ELST	(NE_MGMT_BASE + 16)	/* el stats update; unsolicited */
#define NE_IONS	(NE_MGMT_BASE + 17)	/* start nfs agents */
#define NE_IOPM	(NE_MGMT_BASE + 18)	/* set parm ioctl */
#define NE_IOEV	(NE_MGMT_BASE + 19)	/* Eagle's software version  */
#define NE_IOAR (NE_MGMT_BASE + 20)	/* add route */
#define NE_IODR (NE_MGMT_BASE + 21)	/* delete route */
#define NE_IOGR (NE_MGMT_BASE + 22)	/* get route */
#define NE_IOTD (NE_MGMT_BASE + 23)	/* set transmit delay per ether addr*/
#define NE_IOMA (NE_MGMT_BASE + 24)	/* add multicast addr */
#define NE_IOMD (NE_MGMT_BASE + 25)	/* delete multicast addr */
#define NE_IOEA	(NE_MGMT_BASE + 26)	/* set ethernet address */
#define NE_IOGV	(NE_MGMT_BASE + 27)	/* get software version */
#define NE_IOAI	(NE_MGMT_BASE + 28)	/* add IP address of Unix host */
#define NE_MINV	(NE_MGMT_BASE + 29)

#define NE_DLTX	(NE_DL_BASE   + 0)	/* outbound packet (to network) */
#define NE_DLRX (NE_DL_BASE   + 1)	/* inbound packet (to host) */
#define NE_DINV	(NE_DL_BASE	  + 2)

#define NE_NFSI	(NE_RPC_BASE  + 0)	/* nfs request */
#define NE_NFSO	(NE_RPC_BASE  + 1)	/* nfs reply */
#define NE_RINV	(NE_RPC_BASE  + 2)

#define NE_IINV	(NE_INVL_BASE + 0)

typedef struct ne_noop_s {
	struct ne_mcb ne_no_mcb;
} NE_NO, *NE_NOP;

typedef struct ne_copy_s {
	struct ne_mcb ne_cp_mcb;
	unsigned int  ne_cp_buf;
	unsigned int  ne_cp_len;
} NE_CP, *NE_CPP;

typedef struct ne_dvma_s {
	struct ne_mcb ne_dv_mcb;
} NE_DV, *NE_DVP;

typedef struct ne_xprt_s {
	struct ne_mcb ne_xp_mcb;
} NE_XP, *NE_XPP;

typedef struct ne_dltx_s {
	struct ne_mcb ne_tx_mcb;
	unsigned int  ne_tx_len;	/* length of dma transfer for packet */
#ifdef	NE_DLBUF_CKSUM
	u_short		chksum;         /* check sum for data */
	u_short		unused;		/* 32-bit boundaries */
#endif	NE_DLBUF_CKSUM
} NE_TX, *NE_TXP;

#define NE_DL_HOST	0xffffffff

typedef struct ne_dlrx_s {
	struct ne_mcb ne_rx_mcb;
	unsigned int  ne_rx_board;	/* board packet should be forwarded to */
#ifdef	NE_DLBUF_CKSUM
	u_short		chksum;         /* check sum for data */ 
	u_short		unused;         /* 32-bit boundaries */ 
#endif	NE_DLBUF_CKSUM
} NE_RX, *NE_RXP;

typedef struct ne_rpci_s {
	struct ne_mcb ne_ri_mcb;
	unsigned int  ne_ri_len;	/* length of dma transfer for request */
#ifdef  NE_NFSBUF_CKSUM
	u_short         chksum;         /* check sum for data */
	u_short         unused;         /* 32-bit boundaries */
#endif  NE_NFSBUF_CKSUM
} NE_RI, *NE_RIP;

typedef struct ne_rpco_s {
	struct ne_mcb ne_ro_mcb;
	unsigned int  ne_ro_len;	/* length of dma transfer for reply */
	unsigned int  ne_ro_buf;	/* address in bufram where reply goes */
	unsigned int  ne_ro_mrep;	/* mbuf chain where reply could partly go */
	int           ne_ro_mlen;	/* length to transfer to mbuf chain */
#ifdef  NE_NFSBUF_CKSUM
	u_short         chksum;         /* check sum for data */
	u_short         unused;         /* 32-bit boundaries */
#endif  NE_NFSBUF_CKSUM
} NE_RO, *NE_ROP;

typedef struct ne_iocs_s {
	struct ne_mcb ne_io_mcb;
} NE_IO, *NE_IOP;

typedef struct ne_ioas_s {
	struct ne_mcb ne_as_mcb;	/* cookie has inet address */
	char ne_as_haddr[8];		/* hardware address */
	unsigned int  ne_as_flags;	/* flags */
} NE_AS, *NE_ASP;

/* receive after agent is started */
typedef struct ne_ioev_s {
	struct ne_mcb ne_ev_mcb;
	char ne_ev_vers[VERSION_SIZE];
} NE_EV, *NE_EVP;

/* this dl stats is used for sending unsolicited 
 * updates to the host, to be used by perfmeter
 * and netstat. Not to be confused with ne_el_stat
 * above, used for nestat responses.
 */
struct ne_elst {
	unsigned int ne_elst_ipackets;
	unsigned int ne_elst_ierrors;
	unsigned int ne_elst_opackets;
	unsigned int ne_elst_oerrors;
	unsigned int ne_elst_collisions;
	unsigned int ne_elst_txstatus;
	unsigned int ne_elst_fram;
	unsigned int ne_elst_crc;
	unsigned int ne_elst_oflo;
	unsigned int ne_elst_uflo;
	unsigned int ne_elst_tlcol;
	unsigned int ne_elst_trtry;
	unsigned int ne_elst_tnocar;
};

typedef struct ne_elst_s {
	struct ne_mcb ne_el_mcb;
	struct ne_elst ne_el_st;	/* el stats */
} NE_EL, *NE_ELP;

typedef struct ne_parm_s {
	struct ne_mcb ne_pm_mcb;	/* if cookie != 0, it points to a buffer with parms */
	unsigned int  ne_pm_ref;	/* parm reference number */
	unsigned int  ne_pm_val;	/* parm value */
} NE_PM, *NE_PMP;

typedef struct ne_route_s {
	struct ne_mcb ne_rt_mcb;	/* cookie has inet address */
	unsigned int  ne_rt_flags;	/* e.g. UP, HOST */
	unsigned int  ne_rt_gateway;	/* gateway ip address */
} NE_RT, *NE_RTP;

typedef struct ne_txdelay_s {
	struct ne_mcb ne_td_mcb;	
	unsigned int  ne_td_count;	/* delay counts */
	char ne_td_ether[8];		/* last 2 bytes are padded to null*/
} NE_TD, *NE_TDP;

/* omninet uses this structure to pass info to driver */
#define DEFAULT_DELAY	50	
struct ne_txdelay {
	unsigned int td_count;	      /* delay count */
	char	td_ether[6];	      /* 6 bytes of ethernet address */
};

typedef struct ne_etheraddr_s {
	struct ne_mcb ne_ea_mcb;
	char ne_ea_ether[8];	      /* multicast address */
} NE_EA, *NE_EAP;

/* ne_switch structure to register/advertise ne routines needed by outside world */
/* (currently only route.c needs to call add/delete route routines) */
typedef struct neswitch {
	int	(*ne_delroute)();		/* delete route routine */
	int	(*ne_addroute)();		/* add route routine */
};
extern struct neswitch neswitch;

#endif  _nereg_h
