#!/bin/sh
#
# %W% %E%	Sun Microsystems Computer Corporation
#	From 1.2 1/2/92 Interphase
#
############################################################################
# This code is copyright 1991 by Interphase Corporation.		   #
# All rights reserved.							   #
#									   #
# This code contains confidential information and trade secrets of	   #
# Interphase Corporation which shall not be reproduced or		   #
# transferred to other programs or disclosed to others or used for	   #
# manufacturing or any other purpose without prior written permission of   #
# Interphase Corporation.  Use of copyright notice is precautionary        #
# and does not imply publication or intent thereof.			   #
############################################################################

Error () {
	fmt -79 <<- EOF
	
	$*
	
	EOF
	exit 1
}

PATH=/usr/bin:/usr/ucb:/usr/etc:$PATH ; export PATH
DIR=${PROTO}/dev
FILE=MAKEDEV.ne
ORIG=$FILE.old
FULLNAME="$ROOT_DIR$DIR/$FILE"
cd $ROOT_DIR$DIR

###################################################################
# Check that files exist.
###################################################################

if [ ! -f $FILE ]
then
	Error Cannot edit $FULLNAME -- file does not exist. \
	This indicates that either the tape unloading process or the \
	copying of $FILE from the tape unloading area into $ROOT_DIR$DIR \
	has failed.
fi

if [ -f /usr/tmp/devHigh.snc ] ; then
	devHigh=`cat /usr/tmp/devHigh.snc`
	rm -f /usr/tmp/devHigh.snc
else
	CONF_FILE=${ROOT_DIR}${PROTO}/sys/sun/conf.c

	# We've lost the devHigh.snc file, so re-examine conf.c.
	if [ ! -f $CONF_FILE ] ; then
		Error Cannot edit $FULLNAME -- neither \
		  /usr/tmp/devHigh.snc nor $CONF_FILE \
		  exist.
	fi
	# see if neopen/neclose are there and use that number if so:
	devHigh=`sed -n \
	  -e "s~^${WS}neopen,${WS}neclose,.*/\*\([0-9][0-9]*\)\*/.*$~\1~p" \
	  $CONF_FILE`
	# if not, look at the last existing device number and add one:
	if [ ! "$devHigh" ] ; then
	  devHigh=`sed -n -e \
	    "/^${OWS}struct${WS}cdevsw/,\$ s/^.*\/\*\([0-9][0-9]*\)\*\/$/\1/p" \
	    $ORIG | tail -1`
	  devHigh=`expr $devHigh + 1`
	fi
	# else give up.
	if [ ! "$devHigh" ] ; then
	  Error Cannot edit $FULLNAME -- cannot determine \
	    major device number for the ONC.
	fi
fi

###################################################################
# Check that original file contains the key string.
###################################################################

if grep -s '^necmaj=' $FILE
then
	: OK
else
	Error Cannot edit $FULLNAME -- the required pattern \
	'"^necmaj="' is missing. "

" 	This probably indicates that $FULLNAME has been edited beyond \
	the recognition of this script.  Please see the SNC Installation \
	Manual for instructions on manual editing.

fi

###################################################################
# Ensure original gets restored if we're interrupted.
###################################################################

cp -p $FILE $ORIG
trap "mv -f $ORIG $FILE ; exit" 2 3 6 15

###################################################################
# Perform the edit.
###################################################################

echo Editing $FULLNAME
sed -e "s/^\(necmaj=\)\([0-9][0-9]*\)$/\1${devHigh}/" $ORIG > $FILE

trap 2 3 6 15
rm -f $ORIG /usr/tmp/devHigh.snc

exit 0
